summaryrefslogtreecommitdiffstats
path: root/apps/files_external/tests
diff options
context:
space:
mode:
authorThomas Müller <thomas.mueller@tmit.eu>2015-02-16 13:56:40 +0100
committerThomas Müller <thomas.mueller@tmit.eu>2015-02-16 13:56:40 +0100
commit6cdc7a890a4a6eb20060c922a351fb24221c7cb7 (patch)
treec0102df0bbfa0f24462877deb5931ee5da35d79a /apps/files_external/tests
parent78febb2ee594bac5d483f7c8534ed5eb33c2c528 (diff)
parent60cadf5647f44437cb5faa76a2888a70f00dbeb4 (diff)
downloadnextcloud-server-6cdc7a890a4a6eb20060c922a351fb24221c7cb7.tar.gz
nextcloud-server-6cdc7a890a4a6eb20060c922a351fb24221c7cb7.zip
Merge pull request #14076 from owncloud/autotest-external-ftp
[files_external] ftp tests
Diffstat (limited to 'apps/files_external/tests')
-rw-r--r--apps/files_external/tests/backends/ftp.php8
-rwxr-xr-xapps/files_external/tests/env/start-ftp-morrisjobke.sh65
-rwxr-xr-xapps/files_external/tests/env/stop-ftp-morrisjobke.sh36
3 files changed, 105 insertions, 4 deletions
diff --git a/apps/files_external/tests/backends/ftp.php b/apps/files_external/tests/backends/ftp.php
index 842b7f43fa8..d62759889b1 100644
--- a/apps/files_external/tests/backends/ftp.php
+++ b/apps/files_external/tests/backends/ftp.php
@@ -15,12 +15,12 @@ class FTP extends Storage {
parent::setUp();
$id = $this->getUniqueID();
- $this->config = include('files_external/tests/config.php');
- if ( ! is_array($this->config) or ! isset($this->config['ftp']) or ! $this->config['ftp']['run']) {
+ $this->config = include('files_external/tests/config.ftp.php');
+ if ( ! is_array($this->config) or ! $this->config['run']) {
$this->markTestSkipped('FTP backend not configured');
}
- $this->config['ftp']['root'] .= '/' . $id; //make sure we have an new empty folder to work in
- $this->instance = new \OC\Files\Storage\FTP($this->config['ftp']);
+ $this->config['root'] .= '/' . $id; //make sure we have an new empty folder to work in
+ $this->instance = new \OC\Files\Storage\FTP($this->config);
$this->instance->mkdir('/');
}
diff --git a/apps/files_external/tests/env/start-ftp-morrisjobke.sh b/apps/files_external/tests/env/start-ftp-morrisjobke.sh
new file mode 100755
index 00000000000..3831e788e5e
--- /dev/null
+++ b/apps/files_external/tests/env/start-ftp-morrisjobke.sh
@@ -0,0 +1,65 @@
+#!/bin/bash
+#
+# ownCloud
+#
+# This script start a docker container to test the files_external tests
+# against. It will also change the files_external config to use the docker
+# container as testing environment. This is reverted in the stop step.W
+#
+# Set environment variable DEBUG to print config file
+#
+# @author Morris Jobke
+# @copyright 2015 Morris Jobke <hey@morrisjobke.de>
+#
+
+if ! command -v docker >/dev/null 2>&1; then
+ echo "No docker executable found - skipped docker setup"
+ exit 0;
+fi
+
+echo "Docker executable found - setup docker"
+
+echo "Fetch recent morrisjobke/docker-proftpd docker image"
+docker pull morrisjobke/docker-proftpd
+
+# retrieve current folder to place the config in the parent folder
+thisFolder=`echo $0 | replace "env/start-ftp-morrisjobke.sh" ""`
+
+if [ -z "$thisFolder" ]; then
+ thisFolder="."
+fi;
+
+user=test
+password=12345
+
+container=`docker run -d -e USERNAME=$user -e PASSWORD=$password morrisjobke/docker-proftpd`
+
+host=`docker inspect $container | grep IPAddress | cut -d '"' -f 4`
+
+cat > $thisFolder/config.ftp.php <<DELIM
+<?php
+
+return array(
+ 'run'=>true,
+ 'host'=>'$host',
+ 'user'=>'$user',
+ 'password'=>'$password',
+ 'root'=>'',
+);
+
+DELIM
+
+echo "ftp container: $container"
+
+# put container IDs into a file to drop them after the test run (keep in mind that multiple tests run in parallel on the same host)
+echo $container >> $thisFolder/dockerContainerMorrisJobke.$EXECUTOR_NUMBER.ftp
+
+if [ -n "$DEBUG" ]; then
+ cat $thisFolder/config.ftp.php
+ cat $thisFolder/dockerContainerMorrisJobke.$EXECUTOR_NUMBER.ftp
+fi
+
+# TODO find a way to determine the successful initialization inside the docker container
+echo "Waiting 5 seconds for ftp initialization ... "
+sleep 5
+
diff --git a/apps/files_external/tests/env/stop-ftp-morrisjobke.sh b/apps/files_external/tests/env/stop-ftp-morrisjobke.sh
new file mode 100755
index 00000000000..d8c6cc4f307
--- /dev/null
+++ b/apps/files_external/tests/env/stop-ftp-morrisjobke.sh
@@ -0,0 +1,36 @@
+#!/bin/bash
+#
+# ownCloud
+#
+# This script stops the docker container the files_external tests were run
+# against. It will also revert the config changes done in start step.
+#
+# @author Morris Jobke
+# @copyright 2015 Morris Jobke <hey@morrisjobke.de>
+#
+
+if ! command -v docker >/dev/null 2>&1; then
+ echo "No docker executable found - skipped docker stop"
+ exit 0;
+fi
+
+echo "Docker executable found - stop and remove docker containers"
+
+# retrieve current folder to remove the config from the parent folder
+thisFolder=`echo $0 | replace "env/stop-ftp-morrisjobke.sh" ""`
+
+if [ -z "$thisFolder" ]; then
+ thisFolder="."
+fi;
+
+# stopping and removing docker containers
+for container in `cat $thisFolder/dockerContainerMorrisJobke.$EXECUTOR_NUMBER.ftp`; do
+ echo "Stopping and removing docker container $container"
+ # kills running container and removes it
+ docker rm -f $container
+done;
+
+# cleanup
+rm $thisFolder/config.ftp.php
+rm $thisFolder/dockerContainerMorrisJobke.$EXECUTOR_NUMBER.ftp
+